## mstch 1.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(mstch)

option(WITH_UNIT_TESTS "enable building unit test executable" OFF)
option(WITH_BENCHMARK "enable building benchmark executable" OFF)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
set(CMAKE_BUILD_TYPE Release)

set(mstch_VERSION 1.0.1)

if(NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra -O3")
endif()

add_subdirectory(src)

if(WITH_UNIT_TESTS)
  enable_testing()
  add_subdirectory(vendor/headerize)
  add_subdirectory(test)
endif()

if(WITH_BENCHMARK)
  add_subdirectory(vendor/benchmark)
  add_subdirectory(benchmark)
endif()

=== benchmark/CMakeLists.txt ===
include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/vendor/benchmark/include)

add_executable(mstch_benchmark benchmark_main.cpp)
target_link_libraries(mstch_benchmark mstch benchmark)

=== src/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED)

set(mstch_INCLUDE_DIR
    ${PROJECT_SOURCE_DIR}/include CACHE STRING "mstch include directory")

include_directories(
    ${mstch_INCLUDE_DIR}
    ${Boost_INCLUDE_DIR})

set(SRC
    state/in_section.cpp
    state/outside_section.cpp
    state/render_state.hpp
    visitor/get_token.hpp
    visitor/has_token.hpp
    visitor/is_node_empty.hpp
    visitor/render_node.hpp
    visitor/render_section.hpp
    mstch.cpp
    render_context.cpp
    template_type.cpp
    token.cpp
    utils.cpp)

add_library(mstch STATIC ${SRC})

set_property(TARGET mstch PROPERTY VERSION ${mstch_VERSION})

install(
    TARGETS mstch EXPORT mstchTargets
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)

install(
    FILES "${PROJECT_SOURCE_DIR}/include/mstch/mstch.hpp"
    DESTINATION include/mstch
    COMPONENT Devel)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/mstch/mstch-config-version.cmake"
    VERSION ${mstch_VERSION}
    COMPATIBILITY AnyNewerVersion)

export(
    EXPORT mstchTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/mstch/mstch-targets.cmake"
    NAMESPACE mstch::)

configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/mstch-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/mstch/mstch-config.cmake")

install(
    EXPORT mstchTargets
    FILE mstch-targets.cmake
    NAMESPACE mstch::
    DESTINATION lib/cmake/mstch)

install(FILES
    "${PROJECT_SOURCE_DIR}/cmake/mstch-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/mstch/mstch-config-version.cmake"
    DESTINATION lib/cmake/mstch
    COMPONENT Devel)

=== test/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/vendor/Catch/single_include
  ${CMAKE_SOURCE_DIR}/vendor/rapidjson/include
  ${Boost_INCLUDE_DIR})

file(GLOB data_files RELATIVE
  "${CMAKE_SOURCE_DIR}/test/data"
  "${CMAKE_SOURCE_DIR}/test/data/*.hpp")

foreach(data_file ${data_files})
  string(REGEX REPLACE "\\.hpp" "" test_name "${data_file}")
  list(APPEND tests "${test_name}")
endforeach(data_file)

file(GLOB string_files RELATIVE
  "${CMAKE_SOURCE_DIR}/test/data"
  "${CMAKE_SOURCE_DIR}/test/data/*.mustache"
  "${CMAKE_SOURCE_DIR}/test/data/*.txt"
  "${CMAKE_SOURCE_DIR}/test/data/*.partial")

foreach(string_file ${string_files})
  list(APPEND genargs "-i${string_file}")
endforeach(string_file)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/test_data.hpp
  COMMAND headerize --output ${CMAKE_CURRENT_BINARY_DIR}/test_data.hpp --namespace mstchtest ${genargs}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test/data/)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/test_data.hpp PROPERTIES GENERATED TRUE)
add_custom_target(test_data_hpp DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/test_data.hpp)

file(GLOB specs_files RELATIVE
  "${CMAKE_SOURCE_DIR}/vendor/spec/specs"
  "${CMAKE_SOURCE_DIR}/vendor/spec/specs/*.json")

foreach(specs_file ${specs_files})
  list(APPEND specsargs "-i${specs_file}")
  string(REGEX REPLACE "\\.json" "" test_name "${specs_file}")
  string(REGEX REPLACE "~" "" test_name "${test_name}")
  list(APPEND tests "specs_${test_name}")
endforeach(specs_file)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/specs_data.hpp
  COMMAND headerize --output ${CMAKE_CURRENT_BINARY_DIR}/specs_data.hpp --namespace mstchtest ${specsargs}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/vendor/spec/specs/)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/specs_data.hpp PROPERTIES GENERATED TRUE)
add_custom_target(specs_data_hpp DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/specs_data.hpp)

add_executable(mstch_test test_main.cpp)
target_link_libraries(mstch_test mstch)
add_dependencies(mstch_test test_data_hpp specs_data_hpp)

foreach(test ${tests})
  add_test(NAME ${test} COMMAND mstch_test ${test})
endforeach(test)

=== debian/changelog ===
mstch (1.0.2-7) unstable; urgency=medium

  * QA upload.

  * Redirected stderr in autopkgtest to avoid bogus test failure.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 05 Nov 2024 08:13:28 +0100

mstch (1.0.2-6) unstable; urgency=medium

  * QA upload.

  * Corrected working directory of autopkgtest script to fix failure.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 01 Nov 2024 09:34:45 +0100

mstch (1.0.2-5) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 4.1.3 to 4.7.0.
  * Use wrap-and-sort -at for debian control files.
  * Bump debhelper from old 10 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Added patch metadata.
  * Added simple autopkgtest based on code example in upstream README.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 30 Oct 2024 07:54:51 +0100

mstch (1.0.2-4) unstable; urgency=medium

  * QA upload.
  * Set maintainer to Debian QA Group <packages@qa.debian.org>. (see: #963926)

 -- Marcos Talau <talau@debian.org>  Sat, 12 Nov 2022 09:08:12 -0300

mstch (1.0.2-3) unstable; urgency=medium

  * Bump Standards-Version.
  * Add Rules-Requires-Root: no.
  * Fix installation directory for the CMake configuration file.
    Closes: #951647, #897342

 -- Guus Sliepen <guus@debian.org>  Sun, 11 Jul 2021 14:18:54 +0200

mstch (1.0.2-2) unstable; urgency=medium

  * Fix grammar in debian/control.
  * Add Depends: libboost-dev.

 -- Guus Sliepen <guus@debian.org>  Wed, 03 Jan 2018 00:35:05 +0100

mstch (1.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #886129)

 -- Guus Sliepen <guus@debian.org>  Tue, 02 Jan 2018 16:17:02 +0100

=== debian/control ===
Source: mstch
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: cmake (>= 3.0),
               debhelper-compat (= 13),
               libboost-dev (>= 1.54),
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/no1msd/mstch
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/mstch
Vcs-Git: https://salsa.debian.org/debian/mstch.git

Package: libmstch-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libboost-dev (>= 1.54),
         ${misc:Depends},
Description: Mustache implementation in C++11
 Mstch is a complete implementation of {{mustache}} templates using
 modern C++. It's compliant with specifications v1.1.3, including the
 lambda module.
 .
 Mustache is a logic-less template language. As such, it is very well
 suited for programs that are written in a compiled language, such as C
 and C++, as they cannot easily evaluate code found in a template.
 Mustache does however supports a simple conditional and a loop statement.
 .
 This package contains the header files and a static library.

=== debian/tests/control ===
Tests: test-example-code
Depends: @, g++
